#ifndef macrolib_ibis_io_opensink_INCLUDED
#define macrolib_ibis_io_opensink_INCLUDED
#if defined(__GNUC__) && defined(unix)
#  pragma interface "macrolib_ibis_io_opensink.hpp"
#endif
#ifndef macrolib_ibis_io_opensink_export
#  if defined(_WIN32) && !defined(unix)
#    define macrolib_ibis_io_opensink_export __declspec(dllimport)
#  else
#    define macrolib_ibis_io_opensink_export
#  endif
#endif
#include "smash_enum.h"
#include "std_standard.hpp"
using namespace STD;
#include "ieee_electrical_systems.hpp"
using namespace IEEE;
#include "ieee_math_real.hpp"
using namespace IEEE;
#include "macrolib_macrolib_functions.hpp"
using namespace MACROLIB;
namespace MACROLIB
{
class macrolib_ibis_io_opensink_export IBIS_IO_OPENSINK {
public:
const char *mInstanceName;
static char smGF[35];
char mGF[35];
static STANDARD_REAL smGV0;
const STANDARD_REAL C_COMP;
static STANDARD_REAL smGV1;
const STANDARD_REAL KC_COMP_PC;
static STANDARD_REAL smGV2;
const STANDARD_REAL KC_COMP_PU;
static STANDARD_REAL smGV3;
const STANDARD_REAL KC_COMP_PD;
static STANDARD_REAL smGV4;
const STANDARD_REAL KC_COMP_GC;
static STANDARD_REAL smGV5;
const STANDARD_REAL VINH;
static STANDARD_REAL smGV6;
const STANDARD_REAL VINL;
static STANDARD_REAL smGV7;
const STANDARD_REAL VPC_REF;
static STANDARD_REAL smGV8;
const STANDARD_REAL VPD_REF;
static STANDARD_REAL smGV9;
const STANDARD_REAL VGC_REF;
static STANDARD_REAL_VECTOR *smGV10;
STANDARD_REAL_VECTOR &IPC_DATA;
static STANDARD_REAL_VECTOR *smGV11;
STANDARD_REAL_VECTOR &VPC_DATA;
static STANDARD_REAL_VECTOR *smGV12;
STANDARD_REAL_VECTOR &IPD_DATA;
static STANDARD_REAL_VECTOR *smGV13;
STANDARD_REAL_VECTOR &VPD_DATA;
static STANDARD_REAL_VECTOR *smGV14;
STANDARD_REAL_VECTOR &IGC_DATA;
static STANDARD_REAL_VECTOR *smGV15;
STANDARD_REAL_VECTOR &VGC_DATA;
static STANDARD_REAL_VECTOR *smGV16;
STANDARD_REAL_VECTOR &VR1_DATA;
static STANDARD_REAL_VECTOR *smGV17;
STANDARD_REAL_VECTOR &TR1_DATA;
static STANDARD_REAL_VECTOR *smGV18;
STANDARD_REAL_VECTOR &VF1_DATA;
static STANDARD_REAL_VECTOR *smGV19;
STANDARD_REAL_VECTOR &TF1_DATA;
static STANDARD_REAL smGV20;
const STANDARD_REAL VFX_R1;
static STANDARD_REAL smGV21;
const STANDARD_REAL VFX_F1;
static STANDARD_REAL smGV22;
const STANDARD_REAL RFX_R1;
static STANDARD_REAL smGV23;
const STANDARD_REAL RFX_F1;
static STANDARD_REAL smGV24;
const STANDARD_REAL KI_PC;
static STANDARD_REAL smGV25;
const STANDARD_REAL KI_PD;
static STANDARD_REAL smGV26;
const STANDARD_REAL KI_GC;
static STANDARD_REAL smGV27;
const STANDARD_REAL KT_RISE;
static STANDARD_REAL smGV28;
const STANDARD_REAL KT_FALL;
static STANDARD_STRING *smGV29;
STANDARD_STRING &DATAFILE;
static STANDARD_REAL smGV30;
const STANDARD_REAL MAX_DT;
static STANDARD_REAL smGV31;
const STANDARD_REAL VTH_R;
static STANDARD_REAL smGV32;
const STANDARD_REAL VTH_F;
static STANDARD_INTEGER smGV33;
const STANDARD_INTEGER MAXIV_LENGTH;
static STANDARD_INTEGER smGV34;
const STANDARD_INTEGER MAXVT_LENGTH;
static char smPF[7];
static short smPT[7];
static const char *smAN[7];
char mPF[7];
short mPT[7];
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV0;
ELECTRICAL_SYSTEMS_ELECTRICAL &PU_REF;
static double smPE0;
double mPE0;
T_B3CIDispatcher *PU_REF_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV1;
ELECTRICAL_SYSTEMS_ELECTRICAL &PD_REF;
static double smPE1;
double mPE1;
T_B3CIDispatcher *PD_REF_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV2;
ELECTRICAL_SYSTEMS_ELECTRICAL &PAD;
static double smPE2;
double mPE2;
T_B3CIDispatcher *PAD_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV3;
ELECTRICAL_SYSTEMS_ELECTRICAL &IN_D;
static double smPE3;
double mPE3;
T_B3CIDispatcher *IN_D_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV4;
ELECTRICAL_SYSTEMS_ELECTRICAL &EN_D;
static double smPE4;
double mPE4;
T_B3CIDispatcher *EN_D_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV5;
ELECTRICAL_SYSTEMS_ELECTRICAL &PC_REF;
static double smPE5;
double mPE5;
T_B3CIDispatcher *PC_REF_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV6;
ELECTRICAL_SYSTEMS_ELECTRICAL &GC_REF;
static double smPE6;
double mPE6;
T_B3CIDispatcher *GC_REF_dispatchers;
virtual short ElaborateConfiguration(const char *, long) = 0;
public:
IBIS_IO_OPENSINK();
virtual ~IBIS_IO_OPENSINK();
};
extern "C" macrolib_ibis_io_opensink_export const char *MACROLIB_IBIS_IO_OPENSINK_GetGenericName(short);
extern "C" macrolib_ibis_io_opensink_export const char *MACROLIB_IBIS_IO_OPENSINK_GetPortName(short);
extern "C" macrolib_ibis_io_opensink_export void MACROLIB_IBIS_IO_OPENSINK_InitStaticGenericPort(void);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_SetGeneric(const char *, const char *, const char *, const T_B3CIValue *);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_SetPort(short inLang, const char *, const char *, const char *, const char *, void *, long, double, short, short);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_InstantiateUnmappedPort(const char *);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_Elaborate(T_B3CIHandle *, const char *, long, short);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_Initialize(T_B3CIHandle, long, double *);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_Finalize(T_B3CIHandle);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_AmsLink(T_B3CIHandle, long, long **);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_AmsBim(T_B3CIHandle, long, TRANS_PARAM_BIM *, long **);
extern "C" macrolib_ibis_io_opensink_export short MACROLIB_IBIS_IO_OPENSINK_AmsConverge(T_B3CIHandle, long, long **, double *, unsigned char *, ANALYSISTYPE);
}
#endif /* macrolib_ibis_io_opensink_INCLUDED */
