#ifndef macrolib_ibis_vcvs_div_ideal_INCLUDED
#define macrolib_ibis_vcvs_div_ideal_INCLUDED
#include "macrolib_ibis_vcvs_div.hpp"
#if defined(__GNUC__) && defined(unix)
#  pragma interface "macrolib_ibis_vcvs_div_ideal.hpp"
#endif
#ifndef macrolib_ibis_vcvs_div_ideal_export
#  if defined(_WIN32) && !defined(unix)
#    define macrolib_ibis_vcvs_div_ideal_export __declspec(dllimport)
#  else
#    define macrolib_ibis_vcvs_div_ideal_export
#  endif
#endif
#include "std_standard.hpp"
using namespace STD;
namespace MACROLIB {
class macrolib_ibis_vcvs_div_ideal_export IBIS_VCVS_DIV_IDEAL : public IBIS_VCVS_DIV {
public:
typedef short (IBIS_VCVS_DIV_IDEAL::*T_ThunkMethod)(short);
static short smThunk(IBIS_VCVS_DIV_IDEAL *, T_ThunkMethod *, short);
ELECTRICAL_SYSTEMS_VOLTAGE VOUT;
ELECTRICAL_SYSTEMS_VOLTAGE mM1_VOUT;
ELECTRICAL_SYSTEMS_CURRENT IOUT;
ELECTRICAL_SYSTEMS_CURRENT mM1_IOUT;
ELECTRICAL_SYSTEMS_VOLTAGE VIN1;
ELECTRICAL_SYSTEMS_VOLTAGE mM1_VIN1;
ELECTRICAL_SYSTEMS_VOLTAGE VIN2;
ELECTRICAL_SYSTEMS_VOLTAGE mM1_VIN2;
ELECTRICAL_SYSTEMS_VOLTAGE ABSVIN2;
ELECTRICAL_SYSTEMS_VOLTAGE mM1_ABSVIN2;
STANDARD_BOOLEAN NEARZERO;
T_B3CIDispatcher *NEARZERO_dispatchers;
void *mCG1;
unsigned mF1 : 1;
static T_ThunkMethod smPthunk1;
short mP1(short);
void *mCG2;
unsigned mF3 : 1;
static T_ThunkMethod smPthunk2;
short mP2(short);
unsigned mF4 : 1;
static T_ThunkMethod smPthunk4;
short mP4(short);
STANDARD_BOOLEAN_DriverHandle p1_NEARZERO_driver;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tP_through_qP_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tP_root_exp_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tP_through_qIOUT_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tportP_through_qIOUT_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tN_through_qN_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tN_root_exp_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tN_through_qIOUT_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tportN_through_qIOUT_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tPS1_through_qPS1_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tPS1_root_exp_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tNS1_through_qNS1_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tNS1_root_exp_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tPS2_through_qPS2_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tPS2_root_exp_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tNS2_through_qNS2_smp;
ELECTRICAL_SYSTEMS_CURRENT_MatrixPointer tNS2_root_exp_smp;
double *exp_P_5[7];
double *exp_N_6[7];
double *exp_PS1_7[7];
double *exp_NS1_8[7];
double *exp_PS2_9[7];
double *exp_NS2_10[7];
STANDARD_BOOLEAN_DriverHandle ABSVIN2_ABOVE_11_driver;
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e13_q12_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e13_q12_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e13_q12_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e13_q14_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e13_q14_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e13_q14_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e16_q15_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e16_q15_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e16_q15_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e16_q17_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e16_q17_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e16_q17_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e16_q14_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e16_q14_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e16_q14_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e18_q15_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e18_q15_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e18_q15_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e18_q17_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e18_q17_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e18_q17_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
#ifndef ELECTRICAL_SYSTEMS_VOLTAGE_e18_q14_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
#define ELECTRICAL_SYSTEMS_VOLTAGE_e18_q14_ELECTRICAL_SYSTEMS_VOLTAGE_Identifier
typedef ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer ELECTRICAL_SYSTEMS_VOLTAGE_e18_q14_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer;
#endif
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VOUT_across_VOUT_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VOUT_across_P_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VOUT_across_N_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VIN1_across_VIN1_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VIN1_across_PS1_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VIN1_across_NS1_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VIN2_across_VIN2_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VIN2_across_PS2_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer VIN2_across_NS2_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e13_q12_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e13_ABSVIN2q12_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e13_q14_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e13_VIN2q14_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e16_q15_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e16_VOUTq15_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e16_q17_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e16_VIN1q17_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e16_q14_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e16_VIN2q14_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e18_q15_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e18_VOUTq15_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e18_q17_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e18_VIN1q17_smp;
ELECTRICAL_SYSTEMS_VOLTAGE_e18_q14_ELECTRICAL_SYSTEMS_VOLTAGE_MatrixPointer e18_VIN2q14_smp;
static T_ThunkMethod smDthunk_ABSVIN2_ABOVE_11;
short mD_ABSVIN2_ABOVE_11(short);
static T_ThunkMethod smDthunk_STANDARD_DOMAIN;
short mD_STANDARD_DOMAIN(short);
static T_ThunkMethod smDthunk_NEARZERO;
short mD_NEARZERO(short);
STANDARD_BOOLEAN ABSVIN2_ABOVE_11; 
T_B3CIDispatcher *ABSVIN2_ABOVE_11_dispatchers; 
bool ABSVIN2_ABOVE_11_Control();
bool ABSVIN2_ABOVE_11_Initialize(double *);
short Elaborate(const char *, long);
short ElaborateDrivers(void);
short ElaborateDispatchers(void);
virtual short ElaborateConfiguration(const char *, long);
short Initialize(long, double *);
short Finalize(void);
short AmsLink(long, long **);
short AmsBim(long, TRANS_PARAM_BIM *, long **);
short AmsConverge(long, long **, double *, unsigned char *, ANALYSISTYPE);
void CreateDispatchers(void);
void DeleteDispatchers(void);
public:
IBIS_VCVS_DIV_IDEAL();
virtual ~IBIS_VCVS_DIV_IDEAL();
};
extern "C" macrolib_ibis_vcvs_div_ideal_export short MACROLIB_IBIS_VCVS_DIV_IDEAL_Elaborate(T_B3CIHandle *, const char *, long);
extern "C" macrolib_ibis_vcvs_div_ideal_export short MACROLIB_IBIS_VCVS_DIV_IDEAL_Initialize(T_B3CIHandle, long, double *);
extern "C" macrolib_ibis_vcvs_div_ideal_export short MACROLIB_IBIS_VCVS_DIV_IDEAL_Finalize(T_B3CIHandle inInstance);
extern "C" macrolib_ibis_vcvs_div_ideal_export short MACROLIB_IBIS_VCVS_DIV_IDEAL_AmsLink(T_B3CIHandle, long, long **);
extern "C" macrolib_ibis_vcvs_div_ideal_export short MACROLIB_IBIS_VCVS_DIV_IDEAL_AmsBim(T_B3CIHandle, long, TRANS_PARAM_BIM *, long **);
extern "C" macrolib_ibis_vcvs_div_ideal_export short MACROLIB_IBIS_VCVS_DIV_IDEAL_AmsConverge(T_B3CIHandle, long, long **, double *, unsigned char *, ANALYSISTYPE);
}
#endif /* macrolib_ibis_vcvs_div_ideal_INCLUDED */
